!
subroutine DF60(Fun, X, Xout, H, Eps, SI, SE, Error)
!   Fun(x)   
!      .
!  :  , fortran@yandex.ru
!  -, 2005
interface
  real function Fun(X)
  real, intent(in):: X
  end function Fun
end interface
real, intent(in):: Xout
real, intent(inout):: X, H, Eps
real:: SI, SE
integer:: Error
real, parameter:: ARB=0.001, OneP=1.000001, EEE=128.0
double precision, parameter:: C=0.355555555555555556D0,  &
  C1=0.21875D0, C2=0.375D0
double precision, parameter:: CE=1.0835978835978836D0,   &
  CE0=-0.078125D0, CE01=0.42857142857142857D0,  CE1=-0.9375D0,   &
  CE2=-0.46875D0, CE3=0.0625D0, CE4=-0.669642857142857143D-2
logical:: Hdiv2
integer:: N
real, save:: HM16, DX, F4
double precision:: I, Err
double precision, save:: S1, S2
real:: F0, F1, F2, F3, F01, F12, F33, F44, E, Hmin, SaveH, R
!begin
    if (X==Xout) then
      H=0.0; SI=0.0; SE=0.0; Error=1; return
    end if
    HM16=16.0*epsilon(1.0)
    if (abs(X)>ARB) then; Hmin=HM16*abs(X)
                    else; Hmin=HM16*ARB
    end if
    DX=Xout-X
    if (abs(DX)<2.0*Hmin) then
      H=DX
      SI=0.5*H*(Fun(X)+Fun(Xout)); SE=0.0
      X=Xout; Error=1; return
    end if
    if (Eps<epsilon(1.0)/EEE) then
      Eps=epsilon(1.0)/EEE; SI=0.0; SE=0.0
      Error=2; return
    end if
    if (abs(H)<Hmin) H=Hmin
    H=sign(H, DX); S1=0.D0; S2=0.D0; F4=Fun(X)
    N=0; Hdiv2=.false.
    Error=0
DO
  if (2.0*abs(H)>abs(DX)) then
    SaveH=H
    if (abs(H)>=abs(DX)) then; H=DX; N=1
                         else; H=0.5*DX; N=2
    end if
  end if
10 continue
  F0=F4
  F2=Fun(X+0.5*H); F4=Fun(X+H)
20 continue
  F1=Fun(X+0.25*H); F3=Fun(X+0.75*H)
30 continue
  F01=Fun(X+0.125*H); F12=Fun(X+0.375*H)
  I=C*H*(C1*F0+C1*F4+C2*F2+F1+F3)
  Err=CE*H*(CE4*F4+CE0*F0+CE2*F2+CE1*F1+CE3*F3+CE01*F01+F12)
  if (sngl(dabs(I))>ARB) then; E=sngl(dabs(Err)/dabs(I))
                  else; E=sngl(dabs(Err)/ARB)
  end if
  E=E/(EEE*Eps)
  if (E>1.0) then
    if (abs(X)>ARB) then; Hmin=HM16*abs(X)
                    else; Hmin=HM16*ARB
    end if
    if (abs(H)<Hmin*OneP) then
      SI=sngl(S1); SE=sngl(S2); Error=65; return
    end if
    H=0.5*H; N=2*N
    if (abs(H)<Hmin) then
      H=sign(Hmin,H); N=0
      Hdiv2=.false.; goto 10
    end if
    F44=F4; F33=F3; F4=F2; F3=F12; F2=F1; F1=F01
    Hdiv2=.true.; goto 30
  end if
  X=X+H; S1=S1+I; S2=S2+Err
  if (N>0) then
    N=N-1
    if (N==0) then
      H=SaveH; SI=sngl(S1); SE=sngl(S2); return
    end if
  end if
  if (Hdiv2) then
    F0=F4; F2=F33; F4=F44
    Hdiv2=.false.; goto 20
  end if
  if (N>0.AND.N<5) goto 10
  if (E>6.1222E-6) then
    R=0.9/(E**(1.0/7.0))
  else
    R=5.0
  end if
  N=0; H=H*R; DX=Xout-X
END DO
end subroutine DF60
